#include <wx/event.h>
#include <wx/string.h>

DECLARE_EVENT_TYPE( E_MyEvent, -1 )

class C_MyEvent: public wxCommandEvent
{
public:
    C_MyEvent( wxEventType commandType = E_MyEvent, int id = 0 ) : wxCommandEvent(commandType, id) { }
    wxEvent* Clone() const { return new C_MyEvent(*this); }

    wxString GetText() const { return m_Text; }
    void SetText( const wxString& text ) { m_Text = text;}

private:
    wxString m_Text;
};

typedef void (wxEvtHandler::*MyEventFunction)(C_MyEvent &);
#define MyEventHandler(func) (wxObjectEventFunction)(wxEventFunction)(wxCommandEventFunction) wxStaticCastEvent(MyEventFunction, &func)

enum
{
   ThreadUserMessage = 1, ThreadError, ThreadDebug, ThreadVerbose, ThreadFailure
};



class CustomThread : public wxThread
{
public:
  CustomThread(wxEvtHandler *);
  ~CustomThread();
  void SendThreadMessage(wxString,int);
  virtual void * Entry();
protected:
private:
    wxEvtHandler * EH;
};
